
class Car:
    CAPACITY = 50.0  # 50L of fuel
    FUEL_EFFICIENCY = 8.9  # 8.9L/100km
    DOLLARS_PER_LITRE = 1.59  # $1.59/L of gas
    SPEED = 60.0  # averages 60km/hour

    def __init__(self):
        self.fuel = self.CAPACITY
        self.totalDistance = 0.0

    def CarAddFuel(self, amount):
        self.fuel += amount
        if self.fuel > self.CAPACITY:
            print("Fuel overflow, capping at " + str(self.CAPACITY) + "L.")
            self.fuel = self.CAPACITY

    def GetCarDistance(self):
        # Calculate car distance logic
        return self.totalDistance

    def GetCarTime(self):
        time = self.totalDistance / self.SPEED
        return time

    def GetCarFuelLevel(self):
        # Calculate car fuel consumption logic
        return self.fuel

    def GetCarFuelCost(self):
        cost = self.totalDistance * self.FUEL_EFFICIENCY / 100.0 * self.DOLLARS_PER_LITRE
        return cost

    def CarTravel(self, distance):
        maxDistance = self.fuel / (self.FUEL_EFFICIENCY / 100.0)
        if maxDistance < distance:
            print("Not enough fuel to travel " + str(distance) + "km. Travelling " + str(maxDistance) + "km instead.")
            self.totalDistance += maxDistance
            self.fuel = 0.0
        else:
            self.totalDistance += distance
            self.fuel -= distance * self.FUEL_EFFICIENCY / 100.0
